#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

    struct Input {
    vector<double> numbers;
    size_t bin_count{};
    };

    Input
    input_data(){

    size_t number_count;
    cin >> number_count;
    Input in;

    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++) {
    cin >> in.numbers[i];
    }

    size_t bin_count;
    cin >> in.bin_count;
    return in;
    }

    void find_minmax(const vector<double> numbers, double& min, double& max)
    {
    max = numbers[0];
    min = numbers[0];
    for(size_t i = 0; i < numbers.size(); i++)
        {
        if (numbers[i] > max) max = numbers[i];
        if (numbers[i] < min) min = numbers[i];
        }
    }

    vector<double> make_histogram(const vector<double> numbers, size_t bin_count)
    {
    double min, max;
    find_minmax(numbers, min, max);
    vector<double> bins;

    size_t cor_size = (max - min)/bin_count;

    for (size_t i = 0; i < numbers.size(); i++)
    {
        bool flag = false;
        for (size_t j = 0; (j < bin_count - 1) && !flag; j++)
        {
           auto L = min + j*cor_size;
           auto H = min + (j+1)*cor_size;
           if ((L <= numbers[i]) && (numbers[i] < H))
           {
               flag = true;
               bins[j]++;
           }
        }
        if (!flag) bins[bin_count-1]++;
    }

    return bins;
    }

    void show_histogram_text(vector<double> bins, const vector<double> numbers, size_t bin_count)
    {
    const size_t MAX_ASTERISK = 76;
    int maxb = bins[0];
    size_t H;

    for (size_t j = 1; j < bin_count; j++)
    {
        if (bins[j] > maxb) maxb = bins[j];
    }

    for (size_t j = 0; j < bin_count; j++)
    {
        if (maxb > MAX_ASTERISK)
        {
            H  = MAX_ASTERISK * (static_cast<double>(bins[j]) / maxb);
        }
        else H = bins[j];
        if (bins[j] < 100) cout << " ";
        if (bins[j] < 10) cout << " ";
        cout << bins[j] << "|";
        for (size_t i = 0; i < H; i++) cout << "*";
        cout << endl;
    }
    }

/////////////////////////////////////////////////////////
int main()
{
    auto in = input_data();
/////////////////////////////////////////////////////////
    if (in.bin_count == 0)
    {
        in.bin_count = sqrt(in.numbers.size());
        if (in.bin_count > 25)
        {
            in.bin_count = 1 + log2(in.numbers.size());
            cout << "sterg";
        }
        else cout << "empirii";
        cout << endl;
    }
/////////////////////////////////////////////////////////
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_text(bins, in.numbers, in.bin_count);

    return 0;
}
